/**
 * @file vaihdamain.cpp
 * Esimerkki aliohjelmasta joka vaihtaa alkioita
 *
 * @author Vesa Lappalainen
 * @version 27.4.2003
 */

#include <iostream>
using namespace std;


/**
 * Vaihdetaan kaksi lukua keskenn
 * @param a ensimminen vaihdettava
 * @param toinen vaihdettava
 * @code
 * <pre name="test">
 *   int a = 3;
 *   int b = 4;
 *   vaihda(&a,&b);
 *   b === 3;
 *   a === 4;
 * </pre>
 * @endcode
 */
void vaihda(int *a, int *b)
{
	int t = *a;
	*a = *b;
	*b = t;
}


/**
 * Vaihdetaan kaksi lukua keskenn
 * @param a ensimminen vaihdettava
 * @param toinen vaihdettava
 * @code
 * <pre name="test">
 *   int a = 3;
 *   int b = 4;
 *   vaihda(a,b);
 *   b === 3;
 *   a === 4;
 * </pre>
 * @endcode
 */
void vaihda(int &a, int &b)
{
    int t = a;
    a = b;
    b = t;
}


void tulosta(int h, int m)
{
  cout << h << ":" << m << endl;
}


int main(void)
{
  int h=12,m=15;
  tulosta(h,m);
  vaihda(&h,&m);
  tulosta(h,m);
  vaihda(h,m);
  tulosta(h,m);
  return 0;
}
